<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~boxplot.js,~scanbquartermonthreportgenerator.js" 
	styles="path.css,~../css/reggie-2.css,~../css/report.css">
	<style>
	canvas
	{
		width: 700px;
		height: 550px;
	}	
	.guide
	{
		position: absolute; 
		z-index: 99; 
		display: none; 
		background-color: #224488;
	}
	</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="Sample processing statistics" 
			/></p:path>
			
		<div id="x-guide" class="guide" style="width: 1px;"></div>
		<div id="y-guide" class="guide" style="height: 1px;"></div>

		<div class="content">
		<form name="reggie" id="wizard" class="wizard">

			<div class="step" id="step-1">
				<div class="step-no">1</div>
				<div class="step-title">Report parameters</div>
				<div class="step-content">

					<table class="step-form" id="report-type-scanbquartermonthreport">						
					<tr>
						<td class="prompt">Report period</td>
						<td valign="top" class="input">
							From <input type="text" name="fromdate" id="fromdate" 
								style="width: 8em;" maxlength="8">&nbsp;
							To <input type="text" name="todate" id="todate" 
								style="width: 8em;" maxlength="8">
						</td>
						<td class="status" id="period.status"></td>
						<td class="help">
							<span id="period.message" class="message"></span>
							[YY]YYMMDD. Define which period the report should cover. 
							Empty fields will include all items.
						</td>
					</tr>	
					<tr>
						<td class="prompt">View type</td>
						<td class="input">
							<select name="viewtype" id="viewtype" style="width: 15em;">
								<option value="QUARTERMONTH" selected="yes">Quarter + Month</option>
								<option value="AUTO">Auto</option>
								<option value="WEEK">Week</option>
								<option value="MONTH">Month</option>
								<option value="QUARTER">Quarter</option>
								<option value="YEAR">Year</option>
							</select>
						</td>
						<td class="status" id="viewtype.status"></td>
						<td class="help">
							<span id="viewtype.message" class="message"></span>
							Auto will adjust the report depending on the size of the period.
							<ul>
								<li>Period shorter than 13 months - samples per month</li>
								<li>Period shorter than 3 years - samples per quarter</li>
								<li>Period is 3 years or greater - samples per year</li>
							</ul>
						</td>
					</tr>
					
					<tr>
						<td class="prompt">Chart site</td>
						<td class="input">
							<select id="sites" name="sites" style="width: 15em;"></select>
						</td>
						<td class="status" id="sites.status"></td>
						<td class="help">
							<span id="sites.message" class="message"></span>
							Select what site to take input data from.
						</td>
					</tr>
					
					<tr>
						<td class="prompt">Chart data</td>
						<td class="input">
							<select name="chartvariant">
								<option value="allcharts" selected="yes">All</option>
								<option value="originalquantitytissue">Original quantity tissue</option>
								<option value="quantitytissueused">Quantity tissue used for SCAN-B specimens</option>
								<option value="histologypiecequantity">Histology piece quantity</option>
								<option value="remainingquantityforscanbspecimen">Remaining quantity for SCAN-B specimens</option>
								<option value="originalquantitydna">Original quantity DNA for SCAN-B extractions</option>
								<option value="originalquantityrna">Original quantity RNA for SCAN-B extractions</option>
								<option value="dnayield">DNA yield</option>
								<option value="rnayield">RNA yield</option>
								<option value="dnayieldcorrected">DNA yield (corrected for only processing half of the lysate volume)</option>
								<option value="rnayieldcorrected">RNA yield (corrected for only processing half of the lysate volume)</option>
								<option value="rnaqc">RNA QC</option>
								<option value="minutestornalater">Min to RNAlater</option>
							</select>
						</td>
						<td valign="top" class="status" id="chartvariant.status"></td>
						<td class="help">
							<span id="chartvariant.message" class="message"></span>
							Select what data to report.
						</td>
					</tr>
					</table>
				</div>
			</div>
			
			<div class="step" id="step-2">
				<div class="step-no">2</div>
				<div class="step-title">Generated report
					<span id="printButton" class="link"><img src="../images/print.png">Print version&hellip;</span>
				</div>
				<div class="step-content" id="step-2-content">
					<div id="reportdiv" style="text-align: center;"></div>
				</div>
			</div>
			
		
		<div id="wizard-status"></div>

		<table class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" /></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
			<td><base:button id="gocreate" title="Generate" image="<%=home+"/images/gonext.png"%>" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
			<td id="gonext-message" class="message"></td>
		</tr>
		</table>
	
		
		</form>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>