var RnaQcExport = function()
{
	var rnaqc = {};
	
	var selectedRnaQc;
	var rinIsValid = [];
	
	// Page initialization
	rnaqc.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', rnaqc.validateStep1);
		Wizard.initFileSelectionField('pdf');
		Events.addEventHandler('qcRunDate', 'change', Wizard.validateDate);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', rnaqc.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', rnaqc.validateStep2);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', rnaqc.submit);

		var frm = document.forms['reggie'];
		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=GetActiveRnaQcBioPlates&numFreeWells=0&bioPlateType=BA_RNAQC';
		Wizard.showLoadingAnimation('Loading RNAQC plates...');
		Wizard.asyncJsonRequest(url, rnaqc.qcPlatesLoaded);
	}
	

	rnaqc.qcPlatesLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		var qcPlates = response.plates;
		
		for (var i = 0; i < qcPlates.length; i++)
		{
			var plate = qcPlates[i];
			if (plate.usedWells > 0)
			{
				var option = new Option(plate.name + ' -- ' + plate.usedWells + ' used wells', plate.id);
				option.bioPlate = plate;
				frm.bioPlates[frm.bioPlates.length] = option;
			}
		}
		
		if (frm.bioPlates.length == 0)
		{
			Wizard.setFatalError('Could not find any bioplates to register.');
			return;
		}
		
		Doc.show('step-1');
		Doc.show('gonext');
		Events.sendChangeEvent('qcRunDate');
	}
	
	rnaqc.validateStep1 = function(event)
	{
		var valid = Wizard.isValid('qcRunDate');
		if (!valid) event.preventDefault();
	}
	
	rnaqc.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];
		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=GetRnaQcItemsOnBioPlate&bioPlateId='+frm.bioPlates.value;
		Wizard.showLoadingAnimation('Loading RNAQC items...');
		Wizard.asyncJsonRequest(url, rnaqc.rnaQcItemsLoaded);
	}

	rnaqc.rnaQcItemsLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		selectedRnaQc = response.rnaqc;
		var selectedBioPlate = frm.bioPlates[frm.bioPlates.selectedIndex].bioPlate;
		
		var html = '<table id="rnaQcTable" class="step-form">';
		// First header row
		html += '<tr>';
		html += '<th>RNA QC</th>';
		html += '<th class="dottedleft">' + Strings.encodeTags(selectedBioPlate.name) + '</th>';
		html += '<th class="dottedleft">RIN¹</th>';
		html += '<th></th>';
		html += '<th class="dottedleft comments">Comments</th>';
		html += '</tr>';


		for (var rnaNo=0; rnaNo < selectedRnaQc.length; rnaNo++)
		{
			var rna = selectedRnaQc[rnaNo];

			html += '<tr class="highlight">';
			html += '<td class="prompt">'+Strings.encodeTags(rna.name)+'</td>';
			html += '<td class="dottedleft">'+Strings.encodeTags(rna.bioWell.location)+'</td>';
			html += '<td class="dottedleft"><input class="required" type="text" name="rin.'+rnaNo+'" id="rin.'+rnaNo+'" style="width: 6em;" maxlength="6"></td>';
			html += '<td class="status" id="rin.'+rnaNo+'.status"></td>';
			html += '<td class="dottedleft comments"><input type="text" name="comment.'+rnaNo+'"></td>';
			html += '</tr>'
		}

		html += '<tr style="border-top: 1px solid #A0A0A0;">';
		html += '<td colspan="5" class="help" style="text-align: left;">¹RIN: a number between 0 and 10 or -100 if no value could be measured.</td>';
		html += '</tr>'
		html += '</table>';
		
		Doc.element('rnaQc').innerHTML = html;
		
		Wizard.setCurrentStep(2);
		Doc.show('goregister');
		Doc.show('gocancel');
		
		Wizard.keepSessionAlive();

		for (var rnaNo=0; rnaNo < selectedRnaQc.length; rnaNo++)
		{
			Events.addEventHandler('rin.'+rnaNo, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'rin.'+(rnaNo+1) });
			Events.addEventHandler('rin.'+rnaNo, 'keypress', Events.numberOnly);
			Events.addEventHandler('rin.'+rnaNo, 'change', rnaqc.rinOnChange, { 'index': rnaNo });
			rinIsValid[rnaNo] = false;
		}

		frm['rin.0'].focus();
	}
	
	rnaqc.rinOnChange = function(event)
	{
		var index = Data.int(event.currentTarget, 'index');
		var rin = parseFloat(event.currentTarget.value);
		
		if ((rin >= 0 && rin <= 10) || rin == -100)
		{
			rinIsValid[index] = true;
			Wizard.setInputStatus('rin.'+index, 'valid');
		}
		else
		{
			rinIsValid[index] = false;
			Wizard.setInputStatus('rin.'+index, 'invalid', 'RIN must be a number between 0 and 10 (or -100)');
		}
	}
	
	rnaqc.validateStep2 = function(event)
	{
		var valid = true;
		for (var rnaNo = 0; rnaNo < rinIsValid.length; rnaNo++)
		{
			if (!rinIsValid[rnaNo])
			{
				Wizard.setInputStatus('rin.'+rnaNo, 'invalid', 'RIN must be a number between 0 and 10 (or -100)');
				valid = false;
			}
		}
		if (!valid) event.preventDefault();
	}

	rnaqc.submit = function()
	{
		var frm = document.forms['reggie'];
		var submitInfo = {};
		
		submitInfo.pdf = frm.pdf.value;
		submitInfo.bioPlate = parseInt(frm.bioPlates.value);
		submitInfo.QCRunDate = frm.qcRunDate.value;
		submitInfo.QCOperator = frm.qcOperator.value;
		submitInfo.comments = frm.comments.value;
		
		var all = [];		
		submitInfo.rnaqc = all;
		
		for (var rnaNo = 0; rnaNo < selectedRnaQc.length; rnaNo++)
		{
			var rna = selectedRnaQc[rnaNo];
			var tmp = {};
			
			tmp.id = rna.id;
			tmp.rin = parseFloat(frm['rin.'+rnaNo].value);
			tmp.comment = frm['comment.'+rnaNo].value;
			
			all[all.length] = tmp;
		}
		
		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=RegisterRinValues';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, rnaqc.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	rnaqc.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}
	return rnaqc;
}();

Doc.onLoad(RnaQcExport.initPage);

